import { jsx as y, jsxs as H } from "react/jsx-runtime";
import z, { useRef as f, useEffect as _, useCallback as W, useState as $, useMemo as J, useId as K, useReducer as Q, useLayoutEffect as L } from "react";
import c from "clsx";
const P = "av-text-input", me = "av-text-input-simple", Y = "av-text-input-wrapper", I = "av-text-input-helper-text";
function Z() {
  const e = f(!1);
  return _(() => (e.current = !0, () => {
    e.current = !1;
  }), []), W(() => e.current, []);
}
const B = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function ee(e) {
  const n = Z(), t = f(0), r = f(null), [a, o] = $(B), l = J(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((p) => {
    const i = p[0];
    i && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      r.current && n() && o(i.contentRect);
    }));
  }), [n]);
  return _(() => (r.current && (l == null || l.observe(r.current, e)), () => {
    l == null || l.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [l, e]), [r, a];
}
function te(e) {
  const n = K();
  if (!e)
    return n;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${n}`;
  if (typeof e == "object") {
    const { id: t, prefix: r = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${r}${t}` : `${r}${n}`;
  }
}
const w = "SET_ANNOUNCEMENT", D = "CLEAR_ANNOUNCEMENT", re = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, ne = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case w:
      return {
        ...e,
        announcement: n.payload
      };
    case D:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ae = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: D
  }), typeof e == "function" && e();
}, S = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: r,
  dispatch: a
}) => {
  clearTimeout(t.current), e !== null && a({
    type: w,
    payload: e
  }), n && (t.current = setTimeout(
    () => ae({
      onAnnouncementClear: r,
      dispatch: a
    }),
    n
  ));
}, le = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: a,
  onAnnouncementClear: o,
  dispatch: l
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(S, t, {
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: o,
    dispatch: l
  }) : S({
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: o,
    dispatch: l
  });
};
function ce({
  children: e,
  className: n,
  politeness: t,
  role: r = null,
  announcementDelay: a,
  clearAnnouncementDelay: o,
  onAnnouncementClear: l,
  visible: p,
  ...i
}) {
  const x = f(null), m = f(null), [s, g] = Q(ne, {
    announcement: null
  });
  let d = t;
  typeof d > "u" && (d = r ? re[r] : "assertive"), _(() => {
    le({
      announcementTimeoutRef: x,
      announcementDelay: a,
      children: e,
      clearAnnouncementDelay: o,
      clearAnnouncementTimeoutRef: m,
      onAnnouncementClear: l,
      dispatch: g
    });
  }, [
    e,
    a,
    o,
    l
  ]);
  const u = c(n, {
    "sr-only": !p
  });
  return /* @__PURE__ */ y(
    "div",
    {
      "aria-live": d,
      ...r && { role: r },
      className: u,
      ...i,
      children: s.announcement
    }
  );
}
/*!
  @versini/ui-liveregion v1.2.6
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_LIVEREGION__ || (window.__VERSINI_UI_LIVEREGION__ = {
    version: "1.2.6",
    buildTime: "12/30/2024 05:27 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const oe = ({
  mode: e
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), se = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), ue = ({
  noBorder: e,
  error: n
}) => c("border-2", {
  "border-border-dark": !e && !n,
  "focus:border-border-dark": !e && n,
  "border-border-error-dark": !e && n,
  "border-transparent": e
}), ie = ({
  disabled: e,
  raw: n,
  error: t,
  mode: r
}) => {
  if (n)
    return "";
  if (e)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (t)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "text-copy-lighter dark:text-copy-error-dark": r === "alt-system"
    });
}, pe = ({
  error: e,
  raw: n,
  mode: t,
  disabled: r
}) => {
  if (n)
    return "";
  if (r)
    return c(
      I,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-lighter": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-lighter": t === "system",
      "text-copy-lighter dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": t === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": t === "alt-system"
    });
}, de = ({
  className: e,
  inputClassName: n,
  raw: t,
  disabled: r,
  noBorder: a,
  error: o,
  mode: l,
  focusMode: p,
  size: i,
  rightElementClassName: x
}) => {
  const m = t ? e : c(
    "relative flex w-full flex-col justify-center",
    Y,
    e
  );
  let s = "";
  switch (i) {
    case "xs":
      s = "h-8";
      break;
    case "sm":
      s = "h-10";
      break;
    case "lg":
      s = "h-14";
      break;
    case "xl":
      s = "h-16";
      break;
    default:
      s = "h-12";
      break;
  }
  const g = t ? c(n) : c(
    P,
    s,
    "rounded-md text-base px-4",
    oe({ mode: l }),
    se({ focusMode: p }),
    ue({ noBorder: a, error: o }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    },
    n
  ), d = t ? void 0 : "sr-only", u = ie({
    disabled: r,
    raw: t,
    error: o,
    mode: l
  }), b = pe({
    error: o,
    raw: t,
    mode: l,
    disabled: r
  }), v = t ? void 0 : c("absolute right-3", x);
  return {
    wrapper: m,
    input: g,
    accessibleLabel: d,
    visibleLabel: u,
    helperText: b,
    rightElement: v
  };
}, ye = z.forwardRef(
  ({
    id: e,
    name: n,
    label: t,
    error: r = !1,
    raw: a = !1,
    className: o,
    inputClassName: l,
    mode: p = "system",
    focusMode: i = "system",
    disabled: x = !1,
    noBorder: m = !1,
    labelId: s,
    labelHidden: g = !1,
    type: d = "text",
    helperText: u = "",
    rightElement: b,
    rightElementClassName: v,
    size: N = "md",
    ...U
  }, M) => {
    const [F, T] = ee(), [O, X] = $(0), k = te({ id: e, prefix: `${P}-` }), j = `${n} error, ${u}`, A = f(null), E = f(null), V = {
      xs: { label: "-25px", helperText: "30px" },
      sm: { label: "-29px", helperText: "34px" },
      md: { label: "-33px", helperText: "38px" },
      lg: { label: "-15px", helperText: "22px" },
      xl: { label: "-19px", helperText: "25px" }
    }, h = de({
      className: o,
      inputClassName: l,
      error: r,
      raw: a,
      focusMode: i,
      disabled: x,
      noBorder: m,
      mode: p,
      size: N,
      rightElementClassName: v
    });
    return L(() => {
      T && T.width && X(T.width + 18 + 10);
    }, [T]), L(() => {
      var R, C;
      const { label: q, helperText: G } = V[N];
      (R = A == null ? void 0 : A.current) == null || R.style.setProperty("--av-text-input-label", q), (C = E == null ? void 0 : E.current) == null || C.style.setProperty(
        "--av-text-input-helper-text",
        G
      );
    }, [N]), /* @__PURE__ */ H("div", { className: h.wrapper, children: [
      /* @__PURE__ */ y(
        "label",
        {
          htmlFor: k,
          id: s,
          className: h.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ y(
        "input",
        {
          ref: M,
          id: k,
          name: n,
          type: d,
          disabled: x,
          placeholder: a ? void 0 : " ",
          className: h.input,
          ...u && { "aria-describedby": `${k}-helper` },
          ...r && { "aria-invalid": "true" },
          ...b && !a && { style: { paddingRight: O } },
          ...U
        }
      ),
      !a && !g && /* @__PURE__ */ y(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: k,
          className: h.visibleLabel,
          children: t
        }
      ),
      u && /* @__PURE__ */ y(
        "div",
        {
          ref: E,
          id: `${k}-helper`,
          className: h.helperText,
          children: u
        }
      ),
      b && /* @__PURE__ */ y(
        "div",
        {
          ref: F,
          className: h.rightElement,
          children: b
        }
      ),
      r && u && /* @__PURE__ */ y(ce, { politeness: "polite", clearAnnouncementDelay: 500, children: j })
    ] });
  }
);
ye.displayName = "TextInput";
export {
  P as TEXT_INPUT_CLASSNAME,
  I as TEXT_INPUT_HELPER_TEXT_CLASSNAME,
  me as TEXT_INPUT_SIMPLE_CLASSNAME,
  Y as TEXT_INPUT_WRAPPER_CLASSNAME,
  ye as TextInput,
  ce as x
};
